Subject: Re: [bug#47350] [PATCH 00/29] Add Zygote (piece for Machine Learning with Julia)

From: Nicolò Balzarotti <[email-masked]>
Date: Tue, 23 Mar 2021 23:48:12 +0100

zimoun <[email-masked]> writes:

> Hi,
Hi!

>
> This adds all the packages required to build Zygote, the source-to-source
> automatic differentiation in Julia.
Wonderful, nice to see the first contribution to julia packages :)

>
> Last, well, I feel motivated to implement an (recursive) importer, even
> inaccurate, it will greatly help.
>
I found yesterday julihub, which might help in that regard a lot.  I'll
share here my notes (still no implementation), if I'm not missing
something obvious, this importer should be super easy.  Let me know what
you think about those:

1. refresh the package list (json)
   curl https://juliahub.com/app/packages/info
2. search the required package (.name field)
3. get info on the package (.metadata.docslink) / pkg.json
   eg. curl 'https://juliahub.com/docs/Convex/Sr0e5/0.14.5/pkg.json'
4. extract:
   - version
   - homepage
   - license
   - repository
   - description
   - direct dependencies (used in propagated-inputs field)
     store them into a list
   - indirect dependencies
     add them to the dependency list
   - binary (jll) dependencies
     tell the user those must be fixed
   - remove duplicates/packages already in guix
   - repeat 4 for each dependency

Thanks, Nicolò